#include <stdio.h>
#include <stdlib.h>
#include "Hash.h"

extern long long modulo;

poly_R Hash(const unsigned char *message, long long message_length, long long degree) {
	poly_R result = (poly_R){degree, NULL};
	result.coefficient = (long long*)malloc(sizeof(long long) * degree);
	
	unsigned char *input = (unsigned char*)malloc(sizeof(unsigned char) * 32);
	unsigned char *output = (unsigned char*)malloc(sizeof(unsigned char) * 32);
	
	sha256(message, message_length, output);
	
	long long i;
	for(i = 0; i < (degree >> 3); i++) {
		long long j;
		for(j = 0; j < 32; j++) {
			*(input + j) = *(output + j);
		}
		
		sha256(input, 32, output);
		
		for(j = 0; j < 8; j++) {
			*(result.coefficient + i * 8 + j) = *(output + 4 * j);
			*(result.coefficient + i * 8 + j) <<= 8;
			*(result.coefficient + i * 8 + j) += *(output + 4 * j + 1);
			*(result.coefficient + i * 8 + j) <<= 8;
			*(result.coefficient + i * 8 + j) += *(output + 4 * j + 2);
			*(result.coefficient + i * 8 + j) <<= 8;
			*(result.coefficient + i * 8 + j) += *(output + 4 * j + 3);
			*(result.coefficient + i * 8 + j) %= modulo;
			//*(result.coefficient + i * 8 + j) =
				//((unsigned long long)*(output + 4 * j) << 24 + (unsigned long long)*(output + 4 * j + 1) << 16 + (unsigned long long)*(output + 4 * j + 2) << 8 + (unsigned long long)*(output + 4 * j + 3));
				
			*(result.coefficient + i * 8 + j) = *(result.coefficient + i * 8 + j) >= 0 ? (*(result.coefficient + i * 8 + j) > modulo / 2 ? *(result.coefficient + i * 8 + j) - modulo : *(result.coefficient + i * 8 + j))
				: (*(result.coefficient + i * 8 + j) < -modulo / 2 ? *(result.coefficient + i * 8 + j) + modulo : *(result.coefficient + i * 8 + j));
		}
	}
	
	return result;
}
