#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "SampleG.h"
#include "RandomGenerator.h"

void Sample_G(long long *x, long long q, long long u, double r) {
	extern long long k;
	//line 1-4
	double *_p = (double*)malloc(sizeof(double) * k);
	
	long long i;
	for(i = 0; i < k; i++) {
		*(_p + i) = generate_Gaussian(0, 2 * r);
	}
	
	*(_p + k - 1) *= 1 / sqrt(3);
	for(i = 0; i < k - 1; i++) {
		*(_p + k - 1) += *(_p + k - 2 - i) / (double)(1 << (i + 1));
		
		if(i + 1 >= 20) {
			break;
		}
	}
	
	long long *p = (long long*)malloc(sizeof(long long) * k);
	
	for(i = 0; i < k; i++) {
		*(p + i) = Oracle_1(*(_p + i), r);
	}
	//line 5-8
	long long v = u;
	
	for(i = 0; i < k; i++) {
		v -= *(p + i) << i;
	}
	v = v % q >= 0 ? v % q : v % q + q;
	
	double c = -v / (double)q;
	long long y = Oracle_1(c, r);
	
	long long *w = (long long*)malloc(sizeof(long long) * k);
	
	for(i = 0; i < k; i++) {
		*(w + i) = (v >> i) % 2 + y * ((q >> i) % 2);
	}
	//line 9-14
	for(i = 0; i < k - 1; i++) {
		*(x + i) = Oracle_2(*(w + i), 2 * r);
		*(w + i + 1) += (*(w + i) - *(x + i)) / 2;
	}
	*(x + k - 1) = *(w + k - 1);
	
	//line 15-16
	for(i = 0; i < k; i++) {
		*(x + i) += *(p + i);
	}
}
