#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "SampleP.h"
#include "RandomGenerator.h"

mat_poly_R Sample_P(long long n, long long q, double s, double r, mat_poly_R _e, mat_poly_R _r) {
	extern long long k;
	
	mat_poly_R result = (mat_poly_R){1, k + 2, NULL};
	result.coefficient = (poly_R*)malloc(sizeof(poly_R) * (k + 2));
	//line 1-2
	double alpha = 3 * r;
	double z = 1 / (1 / (alpha * alpha) - 1 / (s * s));
	//line 3-5
	poly_R _a = inner_product_mat_poly_R(_r, _r);
	poly_K a = (poly_K){_a.degree, NULL};
	a.coefficient = (double*)malloc(sizeof(double) * a.degree);

	poly_R _b = inner_product_mat_poly_R(_e, _r);
	poly_K b = (poly_K){_b.degree, NULL};
	b.coefficient = (double*)malloc(sizeof(double) * b.degree);
	
	poly_R _d = inner_product_mat_poly_R(_e, _e);
	poly_K d = (poly_K){_d.degree, NULL};
	d.coefficient = (double*)malloc(sizeof(double) * d.degree);
	
	long long i;
	for(i = 0; i < n; i++) {
		*(a.coefficient + i) =  *(_a.coefficient + i) * (-z);
		*(b.coefficient + i) =  *(_b.coefficient + i) * (-z);
		*(d.coefficient + i) =  *(_d.coefficient + i) * (-z);
	}
	*a.coefficient += s * s;
	*d.coefficient += s * s;
	//line 6-10
	mat_poly_R _q = generate_Gaussian_mat_poly_R(n, 1, k, sqrt(s * s - alpha * alpha));
	poly_R _c0 = inner_product_mat_poly_R(_r, _q);
	poly_R _c1 = inner_product_mat_poly_R(_e, _q);
	
	mat_poly_K _c = (mat_poly_K){1, 2, NULL};
	_c.coefficient = (poly_K*)malloc(sizeof(poly_K) * 2);
	*_c.coefficient = (poly_K){n, NULL};
	*(_c.coefficient + 1) = (poly_K){n, NULL};
	_c.coefficient -> coefficient = (double*)malloc(sizeof(double) * n);
	(_c.coefficient + 1) -> coefficient = (double*)malloc(sizeof(double) * n);
	
	for(i = 0; i < n; i++) {
		*(_c.coefficient -> coefficient + i) = *(_c0.coefficient + i) * -alpha * alpha / (s * s - alpha * alpha);
		*((_c.coefficient + 1) -> coefficient + i) = *(_c1.coefficient + i) * -alpha * alpha / (s * s - alpha * alpha);
	}
	//line 11-14
	//mat_poly_R _p = generate_Gaussian_mat_poly_R(n, 1, 2, alpha);
	mat_poly_R _p = Sample_2Z(a, b, d, _c);

	*result.coefficient = *_p.coefficient;
	*(result.coefficient + 1) = *(_p.coefficient + 1);
	
	for(i = 0; i < k; i++) {
		*(result.coefficient + 2 + i) = *(_q.coefficient + i);
	}
	
	return result;
}

mat_poly_R Sample_2Z(poly_K a, poly_K b, poly_K d, mat_poly_K c) {
	poly_K c0 = *c.coefficient;
	poly_K c1 = *(c.coefficient + 1);
	
	//poly_R q1 = create_poly_R(d.degree);
	poly_R q1 = Sample_FZ(d, c1);
	
	/*poly_K _q1 = (poly_K){q1.degree, NULL};
	_q1.coefficient = (double*)malloc(sizeof(double) * q1.degree);
	
	long long i;
	for(i = 0; i < _q1.degree; i++) {
		*(_q1.coefficient + i) = *(q1.coefficient + i);
	}*/
	
	//poly_R q0 = create_poly_R(d.degree);
	//poly_R q0 = Sample_FZ(add_poly_K(c0, mul_poly_K(b, mul_poly_K(inv_poly_K(d), sub_poly_K(_q1, c1)))),
					//sub_poly_K(a, mul_poly_K(b, mul_poly_K(inv_poly_K(d), transpose_poly_K(b)))));
					
	poly_R q0 = Sample_FZ(d, c0);
	
	mat_poly_R result = (mat_poly_R){1, 2, NULL};
	result.coefficient = (poly_R*)malloc(sizeof(poly_R) * 2);
	
	*result.coefficient = q0;
	*(result.coefficient + 1) = q1;
	
	return result;
}

poly_R Sample_FZ(poly_K f, poly_K c) {
	long long k;
	for(k = f.degree - 1; k >= 0; k--) {
		if(*(f.coefficient + k) != 0) {
			break;
		}
	}
	
	if(k <= 0) {
		poly_R result = create_poly_R(f.degree);
		if(*f.coefficient >= 0) {
			*result.coefficient = Oracle_1(*c.coefficient, sqrt(*f.coefficient));
		} else {
			*result.coefficient = Oracle_1(*c.coefficient, 0);
		}
		//*result.coefficient = Oracle_1(*c.coefficient, sqrt(*f.coefficient));
		
		return result;
	} else {
		poly_K f0 = create_poly_K(f.degree);
		poly_K f1 = create_poly_K(f.degree);
		poly_K c0 = create_poly_K(f.degree);
		poly_K c1 = create_poly_K(f.degree);
		
		long long i;
		for(i = 0; i < f.degree / 2; i++) {
			*(f0.coefficient + i) = *(f.coefficient + 2 * i);
			*(f1.coefficient + i) = *(f.coefficient + 2 * i + 1);
			
			*(c0.coefficient + i) = *(c.coefficient + 2 * i);
			*(c1.coefficient + i) = *(c.coefficient + 2 * i + 1);
		}
		
		mat_poly_K _c = (mat_poly_K){1, 2, NULL};
		_c.coefficient = (poly_K*)malloc(sizeof(poly_K) * 2);
		
		*_c.coefficient = c0;
		*(_c.coefficient + 1) = c1;
		
		mat_poly_R _q = Sample_2Z(f0, f1, f0, _c);
		
		poly_R q0 = *_q.coefficient;
		poly_R q1 = *(_q.coefficient + 1);
		
		poly_R q = (poly_R){q0.degree, NULL};
		q.coefficient = (long long*)malloc(sizeof(long long) * q.degree);
		
		for(i = 0; i < q.degree / 2; i++) {
			*(q.coefficient + 2 * i) = *(q0.coefficient + i);
			*(q.coefficient + 2 * i + 1) = *(q1.coefficient + i);
		}
		
		return q;
	}
}
